var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};

// components/core/Button.tsx
import React from "react";
import { Button as BootstrapButton } from "react-bootstrap";
function _extends() {
  _extends = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
__name(_extends, "_extends");
var Button = /* @__PURE__ */ __name((props) => /* @__PURE__ */ React.createElement(BootstrapButton, _extends({}, props)), "Button");

// components/core/TooltipTrigger.tsx
import React2 from "react";
import { Tooltip, OverlayTrigger } from "react-bootstrap";
function _extends2() {
  _extends2 = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends2.apply(this, arguments);
}
__name(_extends2, "_extends");
var TooltipTrigger = /* @__PURE__ */ __name((_a) => {
  var _b = _a, { children, trigger, placement = "top" } = _b, rest = __objRest(_b, ["children", "trigger", "placement"]);
  const tooltip = /* @__PURE__ */ React2.createElement(Tooltip, {
    id: "tooltip"
  }, children);
  return /* @__PURE__ */ React2.createElement(OverlayTrigger, _extends2({
    placement
  }, rest, {
    overlay: tooltip
  }), trigger);
}, "TooltipTrigger");

// components/VulcanComponents/bootstrapCoreComponents.ts
var bootstrapCoreComponents = {
  Button,
  TooltipTrigger
};

// components/form/inputs/Checkboxgroup.tsx
import React3, { useState } from "react";
import { FormCheck } from "react-bootstrap";
import without from "lodash/without.js";
import uniq from "lodash/uniq.js";
import isEmpty from "lodash/isEmpty.js";
import { useFormContext, useVulcanComponents } from "@vulcanjs/react-ui";
function _extends3() {
  _extends3 = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends3.apply(this, arguments);
}
__name(_extends3, "_extends");
var otherMarker = "[other]";
var isOtherValue = /* @__PURE__ */ __name((s) => s && typeof s === "string" && s.substr(0, otherMarker.length) === otherMarker, "isOtherValue");
var removeOtherMarker = /* @__PURE__ */ __name((s) => s && typeof s === "string" && s.substr(otherMarker.length), "removeOtherMarker");
var addOtherMarker = /* @__PURE__ */ __name((s) => `${otherMarker}${s}`, "addOtherMarker");
var removeOtherValue = /* @__PURE__ */ __name((a) => {
  return a.filter((s) => !isOtherValue(s));
}, "removeOtherValue");
var OtherComponent = /* @__PURE__ */ __name(({ value, path }) => {
  const { updateCurrentValues } = useFormContext();
  const Components = useVulcanComponents();
  const otherValue = removeOtherMarker(value.find(isOtherValue));
  const withoutOtherValue = removeOtherValue(value);
  const [showOther, setShowOther] = useState(!!otherValue);
  const [textFieldValue, setTextFieldValue] = useState(otherValue);
  const textFieldInputProperties = {
    name,
    value: textFieldValue,
    onChange: (event) => {
      const fieldValue = event.target.value;
      setTextFieldValue(fieldValue);
      const newValue = isEmpty(fieldValue) ? withoutOtherValue : [
        ...withoutOtherValue,
        addOtherMarker(fieldValue)
      ];
      updateCurrentValues({
        [path]: newValue
      });
    }
  };
  const textFieldItemProperties = {
    layout: "elementOnly"
  };
  return /* @__PURE__ */ React3.createElement("div", {
    className: "form-option-other"
  }, /* @__PURE__ */ React3.createElement(FormCheck, {
    layout: "elementOnly",
    label: "Other",
    value: showOther,
    checked: showOther,
    onClick: (event) => {
      const isChecked = event.target.checked;
      setShowOther(isChecked);
      if (isChecked) {
        if (textFieldValue) {
          updateCurrentValues({
            [path]: [
              ...withoutOtherValue,
              addOtherMarker(textFieldValue)
            ]
          });
        }
      } else {
        updateCurrentValues({
          [path]: withoutOtherValue
        });
      }
    }
  }), showOther && /* @__PURE__ */ React3.createElement(Components.FormComponentText, {
    inputProperties: textFieldInputProperties,
    itemProperties: textFieldItemProperties
  }));
}, "OtherComponent");
var FormComponentCheckboxGroup = /* @__PURE__ */ __name(({ refFunction, label, path, value, formType, disabled, inputProperties, itemProperties = {} }) => {
  const { updateCurrentValues } = useFormContext();
  const Components = useVulcanComponents();
  const _a = inputProperties, { options = [], name: name2 } = _a, otherInputProperties = __objRest(_a, ["options", "name"]);
  value = value ? uniq(value.filter((v) => isOtherValue(v) || options.map((o) => o.value).includes(v))) : [];
  const hasValue = value.length > 0;
  if (formType === "new" && value.length === 0) {
    const checkedValues = options.filter((o) => o.checked === true).map((option) => option.value);
    if (checkedValues.length) {
      value = checkedValues;
    }
  }
  return /* @__PURE__ */ React3.createElement(Components.FormItem, _extends3({
    path,
    label
  }, itemProperties), /* @__PURE__ */ React3.createElement("div", {
    className: "form-item-options"
  }, options.map((option, i) => {
    const isChecked1 = value.includes(option.value);
    const checkClass = hasValue ? isChecked1 ? "form-check-checked" : "form-check-unchecked" : "";
    return /* @__PURE__ */ React3.createElement(Form.Check, _extends3({}, otherInputProperties, {
      name: name2,
      layout: "elementOnly",
      key: i,
      label: /* @__PURE__ */ React3.createElement(Components.FormOptionLabel, {
        option,
        name: name2
      }),
      value: isChecked1,
      checked: isChecked1,
      id: `${path}.${i}`,
      path: `${path}.${i}`,
      ref: refFunction,
      onChange: (event) => {
        const isChecked = event.target.checked;
        const newValue = isChecked ? [
          ...value,
          option.value
        ] : without(value, option.value);
        updateCurrentValues({
          [path]: newValue
        });
      },
      className: checkClass
    }));
  }), itemProperties.showOther && /* @__PURE__ */ React3.createElement(OtherComponent, {
    value,
    path
  })));
}, "FormComponentCheckboxGroup");

// components/form/inputs/Radiogroup.tsx
import React4, { useState as useState2, useEffect } from "react";
import { FormCheck as FormCheck2 } from "react-bootstrap";
import isEmpty2 from "lodash/isEmpty.js";
import { useFormContext as useFormContext2, useVulcanComponents as useVulcanComponents2 } from "@vulcanjs/react-ui";
function _extends4() {
  _extends4 = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends4.apply(this, arguments);
}
__name(_extends4, "_extends");
var OtherComponent2 = /* @__PURE__ */ __name(({ value, path }) => {
  const { updateCurrentValues } = useFormContext2();
  const Components = useVulcanComponents2();
  const otherValue = removeOtherMarker(value);
  const [showOther, setShowOther] = useState2(isOtherValue(value));
  const [textFieldValue, setTextFieldValue] = useState2(otherValue);
  useEffect(() => {
    if (value) {
      setShowOther(isOtherValue(value));
    }
  }, [
    value
  ]);
  const textFieldInputProperties = {
    name: path,
    value: textFieldValue,
    onChange: (event) => {
      const fieldValue = event.target.value;
      setTextFieldValue(fieldValue);
      const newValue = isEmpty2(fieldValue) ? null : addOtherMarker(fieldValue);
      updateCurrentValues({
        [path]: newValue
      });
    }
  };
  const textFieldItemProperties = {
    layout: "elementOnly"
  };
  return /* @__PURE__ */ React4.createElement("div", {
    className: "form-option-other"
  }, /* @__PURE__ */ React4.createElement(FormCheck2, {
    name: path,
    layout: "elementOnly",
    label: "Other",
    value: showOther,
    checked: showOther,
    type: "radio",
    onClick: (event) => {
      const isChecked = event.target.checked;
      updateCurrentValues({
        [path]: null
      });
      setShowOther(isChecked);
    }
  }), showOther && /* @__PURE__ */ React4.createElement(Components.FormComponentText, {
    inputProperties: textFieldInputProperties,
    itemProperties: textFieldItemProperties
  }));
}, "OtherComponent");
var FormComponentRadioGroup = /* @__PURE__ */ __name(({ refFunction, path, inputProperties, itemProperties = {} }) => {
  const Components = useVulcanComponents2();
  const { updateCurrentValues } = useFormContext2();
  const _a = inputProperties, { options = [], value } = _a, otherInputProperties = __objRest(_a, ["options", "value"]);
  const hasValue = value !== "";
  return /* @__PURE__ */ React4.createElement(Components.FormItem, _extends4({
    path,
    label: inputProperties.label
  }, itemProperties), options.map((option, i) => {
    const isChecked = value === option.value;
    const checkClass = hasValue ? isChecked ? "form-check-checked" : "form-check-unchecked" : "";
    return /* @__PURE__ */ React4.createElement(Form.Check, _extends4({}, otherInputProperties, {
      key: i,
      layout: "elementOnly",
      type: "radio",
      label: /* @__PURE__ */ React4.createElement(Components.FormOptionLabel, {
        option
      }),
      value: option.value,
      name: path,
      id: `${path}.${i}`,
      path: `${path}.${i}`,
      ref: refFunction,
      checked: isChecked,
      className: checkClass
    }));
  }), itemProperties.showOther && /* @__PURE__ */ React4.createElement(OtherComponent2, {
    value,
    path
  }));
}, "FormComponentRadioGroup");

// components/VulcanComponents/bootstrapFormComponents.ts
var bootstrapFormComponents = {
  FormComponentRadioGroup,
  FormComponentCheckboxGroup
};

// components/VulcanComponents/bootstrapVulcanComponents.ts
var bootstrapVulcanComponents = __spreadValues(__spreadValues({}, bootstrapCoreComponents), bootstrapFormComponents);
export {
  bootstrapCoreComponents,
  bootstrapFormComponents,
  bootstrapVulcanComponents
};
//# sourceMappingURL=index.js.map